//
//  Shader_Blitter_Facing_Textured.vsh
//
//  Copyright (c) 2012 Midoki Ltd. All rights reserved.
//

attribute vec3 position;
attribute vec2 texCoord;
attribute vec3 rotScale;
attribute vec4 colour;

varying lowp vec4 colorVarying;
varying mediump vec2 texCoordVarying;

uniform mat4 viewWorld;
uniform mat4 viewScreen;

void main()
{
	float	sinAngle = sin(rotScale.z);
	float	cosAngle = cos(rotScale.z);
	
	vec2 offsetPos;
	offsetPos.x  = rotScale.x * cosAngle + rotScale.y * sinAngle; 
	offsetPos.y  = rotScale.y * cosAngle - rotScale.x * sinAngle;
	
	vec4 pos = vec4(position, 1);
	pos += viewWorld * vec4(offsetPos, 0, 0);
	
	gl_Position = viewScreen * pos;
	texCoordVarying = texCoord;

	colorVarying = colour * (1.0/255.0);
}

