//
//  Shader_LightTex.vsh
//  CityBuilder
//
//  Created by Jonathan Webb on 18/08/2011.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

//------------------------------------------------------------------------------

#define POS_COMPRESSION_FACTOR				(16.0)	//(16.0)
#define POS_COMPRESSION_FACTOR_SKIN			(256.0)	//(16.0)

#define XYZ_DECOMPRESSION_MULTIPLIER		(1.0/POS_COMPRESSION_FACTOR)
#define XYZ_DECOMPRESSION_MULTIPLIER_SKIN	(1.0/POS_COMPRESSION_FACTOR_SKIN)

//------------------------------------------------------------------------------

attribute vec4 position;
attribute vec2 texCoord;
attribute vec4 color;

//------------------------------------------------------------------------------

uniform mat4 modelViewProjectionMatrix;
uniform vec4 animUV;

//------------------------------------------------------------------------------

varying mediump	vec4 colorVarying;
varying mediump vec2 texCoordVarying;

//------------------------------------------------------------------------------

void main()
{
    
    // Transform the position into screen space.
    vec3 posScaled = (position.xyz * XYZ_DECOMPRESSION_MULTIPLIER);
    gl_Position = modelViewProjectionMatrix * vec4(posScaled, 1.0);
    //gl_Position = modelViewProjectionMatrix * position;

    // Decompress UVs
    //texCoordVarying = animUV.xy + texCoord;
//    texCoordVarying = animUV.xy * animUV.zw + (texCoord/1024.0);

	mediump	vec2	baseUVOffset	= fract(animUV.xy * animUV.zw);

	texCoordVarying.xy				= ((texCoord/1024.0) + baseUVOffset);

    colorVarying = color;
}

//------------------------------------------------------------------------------
