//
//  Shader_LightTex.fsh
//  CityBuilder
//
//  Created by Jonathan Webb on 18/08/2011.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#if defined (ANDROID)
#define TEXTURE2DBIAS(a,b,c)	texture2D(a,b)
#else
#define TEXTURE2DBIAS(a,b,c)	texture2D(a,b,c)
#endif

varying lowp vec4 colorVarying;
varying mediump vec2 texCoordVarying;
varying mediump	vec3 normalVarying;
varying mediump	vec3 eyeDirVarying;

//------------------------------------------------------------------------------

uniform sampler2D texture;

void main()
{
	mediump	float	eyeDotNormal	= dot(-normalize(eyeDirVarying), normalize(normalVarying));
	mediump	float	oneMinusAbsDot	= (1.0 - abs(eyeDotNormal));
	mediump	float	fresnelBack		= clamp(((1.8 * oneMinusAbsDot) - 0.2), 0.0, 1.0);
	mediump	float	fresnelFront	= (1.0 - clamp(eyeDotNormal, 0.0, 1.0)) * (max(0.0, sign(eyeDotNormal)));
	mediump	float	fresnel			= clamp((fresnelBack + (fresnelFront * 0.5)), 0.0, 1.0);

	lowp vec4 texel = (TEXTURE2DBIAS(texture, texCoordVarying, -1.0) * colorVarying);
	
    gl_FragColor = vec4(texel.xyz, (texel.w * (1.0 - fresnel)));
}
