//
//  Shader_LightTex.fsh
//  CityBuilder
//
//  Created by Jonathan Webb on 18/08/2011.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#if defined (ANDROID)
#define TEXTURE2DBIAS(a,b,c)	texture2D(a,b)
#else
#define TEXTURE2DBIAS(a,b,c)	texture2D(a,b,c)
#endif

varying lowp vec4 varying_colour;
varying lowp vec3 varying_fadeValuesAndAboveGround;
varying lowp vec2 texCoordVarying;
varying lowp vec2 varying_screenTexCoord;

uniform sampler2D texture;
uniform sampler2D refractionmap;

void main()
{
//	gl_FragColor = TEXTURE2DBIAS(texture, texCoordVarying, -1.0) * varying_colour;
	
	mediump vec4 texel = TEXTURE2DBIAS(texture, texCoordVarying, -1.0);
	
	mediump vec4 texelScreen = texture2D(refractionmap, varying_screenTexCoord);
	
	if (varying_fadeValuesAndAboveGround.z < 0.0)
	{
		discard;
	}
	
	mediump vec3 finalRGB = (texel.xyz * varying_colour.xyz);
	
//	finalRGB = (finalRGB * (texelScreen.z * texelScreen.z) * 1.5);
	finalRGB = ((finalRGB * (1.0 - varying_fadeValuesAndAboveGround.x)) + (texelScreen.xyz * varying_fadeValuesAndAboveGround.x));
	//	finalRGB = ((finalRGB * (1.0 - varying_fadeValue)) + (vec3(1.0, 1.0, 1.0) * varying_fadeValue));
	//	finalRGB = (finalRGB * texelScreen.z);
	
	//	finalRGB += (texel.xyz * texelScreen.z * texelScreen.z);
	
//	mediump float highlight = (texelScreen.z + 0.2);
//	highlight = (highlight * highlight);
//	highlight = (highlight * highlight);
//	highlight = (highlight * highlight);
//	highlight = (highlight * highlight);
//	highlight = clamp(highlight, 0.0, 0.2);// * varying_fadeValuesAndAboveGround.y;
	
//	finalRGB = (finalRGB * (1.0 - highlight)) + (texel.xyz * highlight * vec3(0.8, 1.0, 1.0));
//	finalRGB = (finalRGB * (1.0 - highlight)) + (texelScreen.xyz * highlight * vec3(0.8, 1.0, 1.0));

	
	gl_FragColor = vec4(finalRGB, 1.0);//varying_colour
}



