//
//  Shader_LightTexSkinned.fsh
//  CityBuilder
//
//  Created by Ben Cohen on 05/04/2012.
//  Copyright (c) 2012 Midoki. All rights reserved.
//

#if defined (ANDROID)
#define TEXTURE2DBIAS(a,b,c)	texture2D(a,b)
#else
#define TEXTURE2DBIAS(a,b,c)	texture2D(a,b,c)
#endif

varying lowp vec4 varying_colour;
varying lowp vec4 varying_fogColour;
varying lowp vec2 texCoordVarying;

uniform sampler2D texture;
uniform mediump vec4 addColour;

void main()
{
//    gl_FragColor = TEXTURE2DBIAS(texture, texCoordVarying, -1.0) * varying_colour;
 
	mediump vec4 texel = TEXTURE2DBIAS(texture, texCoordVarying, -1.0);
	
	mediump vec3 finalRGB = ((texel.xyz * varying_colour.xyz) + varying_fogColour.xyz);

//	finalRGB = ((finalRGB * addColour.w) + addColour.xyz);

	mediump float intensity = dot(finalRGB, vec3(0.3, 0.5, 0.2));
	mediump vec3 tintedRGB = (addColour.xyz + vec3(intensity, intensity, intensity));
	finalRGB = (finalRGB * (1.0 - addColour.w)) + (tintedRGB * addColour.w);

	gl_FragColor = vec4(finalRGB, 1.0);//varying_colour
}
