//
//  Shader_LightTex.fsh
//  CityBuilder
//
//  Created by Jonathan Webb on 18/08/2011.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#if defined (ANDROID)
#define TEXTURE2DBIAS(a,b,c)	texture2D(a,b)
#else
#define TEXTURE2DBIAS(a,b,c)	texture2D(a,b,c)
#endif

varying lowp vec4 colorVarying;
varying lowp vec2 texCoordVarying;

uniform sampler2D texture;

void main()
{
    lowp vec4 rgba = TEXTURE2DBIAS(texture, texCoordVarying, -1.0);

	rgba.w *= sign(max(0.0, texCoordVarying.x));

    if (rgba.w > 0.8)
	{
		gl_FragColor = vec4((rgba.xyz * colorVarying.xyz), 1.0);
	}
	else
	{
		discard;
	}
}
