//
//  Shader_LightTex.vsh
//  CityBuilder
//
//  Created by Jonathan Webb on 18/08/2011.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

//------------------------------------------------------------------------------

#define POS_COMPRESSION_FACTOR				(16.0)	//(16.0)
#define POS_COMPRESSION_FACTOR_SKIN			(256.0)	//(16.0)

#define XYZ_DECOMPRESSION_MULTIPLIER		(1.0/POS_COMPRESSION_FACTOR)
#define XYZ_DECOMPRESSION_MULTIPLIER_SKIN	(1.0/POS_COMPRESSION_FACTOR_SKIN)

#define PI	3.1415926
#define PI2	(PI*2.0)

//------------------------------------------------------------------------------

attribute vec4 position;
attribute vec3 normal;
attribute vec2 texCoord;

//------------------------------------------------------------------------------

uniform mat4 modelViewProjectionMatrix;
uniform mat4 lightDirectionMat;
uniform mat4 lightColorMat;
uniform vec4 flagDeform;

//------------------------------------------------------------------------------

varying mediump vec4 colorVarying;
varying mediump vec2 texCoordVarying;
varying mediump vec2 texCoordVarying2;
varying mediump vec2 texCoordVarying3;

//------------------------------------------------------------------------------

void main()
{
//     // Transform the position into screen space.
//    mediump vec3 posScaled = (position.xyz / POS_COMPRESSION_FACTOR);// - 2000.0;
//    gl_Position = modelViewProjectionMatrix * vec4(posScaled, 1.0);
//    //gl_Position = modelViewProjectionMatrix * position;

    mediump vec3	posScaled		= (position.xyz * XYZ_DECOMPRESSION_MULTIPLIER);// - 2000.0;

	posScaled.x += flagDeform.z;

	mediump float	deformX			= max(posScaled.x, 0.0);
	mediump float	deformRatio1	= (min(deformX, flagDeform.x) / flagDeform.x);
	mediump float	deformRatio2	= (max((deformX - flagDeform.x), 0.0) / (flagDeform.y - flagDeform.x));
	mediump float	deformRatio		= (deformRatio1 - deformRatio2);

mediump float	offsetAngle			= (max(posScaled.x, 0.0) * (0.1 * PI2));
mediump float	deformOffset		= (sin(offsetAngle) * deformRatio1);// * 2.0;

	posScaled.z = ((posScaled.z * deformRatio) + deformOffset);

    // Transform the position into screen space.
    gl_Position = modelViewProjectionMatrix * vec4(posScaled, 1.0);
    //gl_Position = modelViewProjectionMatrix * position;

    // Decompress the UVs
    //texCoordVarying = texCoord;
    texCoordVarying = (texCoord/1024.0);

	texCoordVarying.x += flagDeform.w;

	texCoordVarying3 = (texCoordVarying * 4.0);
	texCoordVarying2 = texCoordVarying3;
	texCoordVarying2.x -= (flagDeform.w * 2.0);
	
#if 1
    //colorVarying = vec4 (normal.x, normal.y, normal.z, 1.0);

    // Create the dot products for the three direction lights.
	mediump vec3 normalN = normalize(normal);
	mediump vec4 dots = lightDirectionMat * vec4(normalN, 0.0);

	// Exaggerate the lighting on the flags...
	dots *= vec4(2.5, 2.5, 2.5, 0.4);
	
    // Clamp dots to between 0 and 1 (make sure the ambient dot is 1).
    dots = clamp (dots, 0.0, 1.0);
    dots.w = 1.0;
    
    // Apply the dots to the color matrix and copy to the output.
    colorVarying = lightColorMat * dots;
#else
    colorVarying = vec4(0.0, 0.0, 1.0, 1.0);
#endif
}

//------------------------------------------------------------------------------
