//
//  Shader_LightTex.fsh
//  CityBuilder
//
//  Created by Jonathan Webb on 18/08/2011.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#if defined (ANDROID)
#define TEXTURE2DBIAS(a,b,c)	texture2D(a,b)
#else
#define TEXTURE2DBIAS(a,b,c)	texture2D(a,b,c)
#endif

uniform sampler2D texture;
uniform sampler2D texture3;
uniform sampler2D texture4;

varying mediump vec4 colorVarying;
varying mediump vec2 texCoordVarying;
varying mediump vec2 texCoordVarying2;
varying mediump vec2 texCoordVarying3;

void main()
{
	mediump vec4 texel0 = TEXTURE2DBIAS(texture, texCoordVarying, -1.0);
	mediump vec4 texel1 = TEXTURE2DBIAS(texture3, texCoordVarying2, -1.0);
	mediump vec4 texel2 = TEXTURE2DBIAS(texture4, texCoordVarying3, -1.0);
	
	texel0.w *= sign(max(0.0, texCoordVarying.x));
	
	if (texel0.w > 0.8)
	{
		mediump vec3 finalRGB = (texel1.xyz * (1.0 - texel2.w)) + (texel2.xyz * texel2.w);
		gl_FragColor = vec4((finalRGB * colorVarying.xyz), 1.0);
	}
	else
	{
		discard;
	}
}
