//
//  Shader_LightTex.fsh
//  CityBuilder
//
//  Created by Jonathan Webb on 18/08/2011.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#if defined (ANDROID)
#define TEXTURE2DBIAS(a,b,c)	texture2D(a,b)
#else
#define TEXTURE2DBIAS(a,b,c)	texture2D(a,b,c)
#endif

varying lowp vec4 colorVarying;
varying mediump vec2 texCoordVarying;

uniform sampler2D texture;

void main()
{
    mediump vec4 colour = TEXTURE2DBIAS(texture, texCoordVarying, -1.0) * colorVarying;
	
/*	// Sepia RGB value
    mediump vec3 sepia = vec3(112.0 / 255.0, 66.0 / 255.0, 20.0 / 255.0);
	
    // Step 1: Convert to grayscale
    //vec3 colour = texture2D(Sample0, vUv).xyz;
	//	mediump float gray = dot(vec3(0.3, 0.59, 0.11), vec3(colour));
	mediump float gray = dot(vec3(0.3, 0.59, 0.51), vec3(colour));
	mediump vec3 grayscale = vec3(gray);
    
    // Step 2: Appy sepia overlay
    mediump vec3 finalColour = 0.5 * grayscale + 1.5 * grayscale * sepia;
    
	// Step 3: Apply a scale and offset to achieve the desired final colour and contrast...
	//	finalColour = (vec3(0.45, 0.4, 0.3) * colour.w) + (finalColour * vec3(0.55, 0.6, 0.7) * 0.5);
	finalColour = (vec3(0.44, 0.39, 0.28) * colour.w) + (finalColour * vec3(0.53, 0.6, 0.7) * 0.5);
    
    // Step 3: Lerp final sepia colour
    //finalColour = grayscale + 0.99 * (finalColour - grayscale);
    gl_FragColor = vec4(finalColour, colour.w);//colour * vec4(0.3, 0.58, 0.114, 1.0);
*/
	
	// NEW sepia shader, rather than completely desaturating the image, just do a simple blend...
	mediump float sepiaLevel = 0.6;
    mediump vec3 sepiaColour = vec3((238.0 / 255.0), (207.0 / 255.0), (150.0 / 255.0));
	mediump vec3 finalColour = ((sepiaColour * sepiaLevel) + (colour.xyz * (1.0 - sepiaLevel)));
	
	gl_FragColor = vec4(finalColour, colour.w);
}
