//
//  Shader_LightTex.vsh
//  CityBuilder
//
//  Created by Jonathan Webb on 18/08/2011.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

//------------------------------------------------------------------------------

#define POS_COMPRESSION_FACTOR				(16.0)	//(16.0)
#define POS_COMPRESSION_FACTOR_SKIN			(256.0)	//(16.0)

#define XYZ_DECOMPRESSION_MULTIPLIER		(1.0/POS_COMPRESSION_FACTOR)
#define XYZ_DECOMPRESSION_MULTIPLIER_SKIN	(1.0/POS_COMPRESSION_FACTOR_SKIN)

#define SHEEN_UV_SCALE				(5.0)
#define SHEEN_ANIM_SCALE			(1.0)

//------------------------------------------------------------------------------

attribute vec4 position;
attribute vec3 normal;
attribute vec2 texCoord;

//------------------------------------------------------------------------------

uniform mat4	modelViewProjectionMatrix;
uniform mat4	lightDirectionMat;
uniform mat4	lightColorMat;
uniform vec4	animUV;

//------------------------------------------------------------------------------

varying lowp vec4 colorVarying;
varying mediump vec2 texCoordVarying;
varying mediump vec2 texCoordVarying2;

//------------------------------------------------------------------------------

void main()
{
    // Transform the position into screen space.
    vec3 posScaled = (position.xyz * XYZ_DECOMPRESSION_MULTIPLIER);
	vec4 posScaled4 = vec4(posScaled, 1.0);
	vec4 posTrans = modelViewProjectionMatrix * posScaled4;

	gl_Position = posTrans;

    // Decompress the UVs
    //texCoordVarying = texCoord;
    texCoordVarying = (texCoord/1024.0);

	mediump mat4 adjustedMatrix = modelViewProjectionMatrix;
	adjustedMatrix[3].xyz = vec3(0.0, 0.0, 0.0);
	vec4 posTrans2 = adjustedMatrix * posScaled4;

	texCoordVarying2.xy = (posTrans2.xy / posTrans2.w);
	//texCoordVarying2.y = -texCoordVarying2.y;
	texCoordVarying2.xy = ((texCoordVarying2.xy * 0.5) + 0.5) * SHEEN_UV_SCALE;

	//mediump vec2 baseUVOffset = fract(animUV.xy * animUV.zw * SHEEN_ANIM_SCALE);
//	texCoordVarying2.x += (animUV.x * SHEEN_ANIM_SCALE);//baseUVOffset.xy;
	texCoordVarying2.x += (animUV.z * SHEEN_ANIM_SCALE);//baseUVOffset.xy;
	texCoordVarying2.y = (2.8 - texCoordVarying2.y);
	
#if 1
    //colorVarying = vec4 (normal.x, normal.y, normal.z, 1.0);

    // Create the dot products for the three direction lights.
	vec4 dots = lightDirectionMat * vec4(normal, 0.0);

    // Clamp dots to between 0 and 1 (make sure the ambient dot is 1).
    dots = clamp (dots, 0.0, 1.0);
    dots.w = 1.0;
    
    // Apply the dots to the color matrix and copy to the output.
    colorVarying = lightColorMat * dots;
#else
    colorVarying = vec4(0.0, 0.0, 1.0, 1.0);
#endif
}

//------------------------------------------------------------------------------

