//
//  Shader_LightTex.fsh
//  CityBuilder
//
//  Created by Jonathan Webb on 18/08/2011.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#if defined (ANDROID)
#define TEXTURE2DBIAS(a,b,c)	texture2D(a,b)
#else
#define TEXTURE2DBIAS(a,b,c)	texture2D(a,b,c)
#endif

#define PAPER_DETAIL_THRESHOLD	(0.5)
#define PAPER_DETAIL_ALPHA		(0.45)
#define PAPER_DETAIL_RGB		vec3(0.48, 0.38, 0.24)
#define PAPER_RGB_SCALE			(0.3)
#define PAPER_RGB_OFFSET		(0.725)

varying lowp vec4 colorVarying;
varying lowp vec2 texCoordVarying;
varying lowp vec2 texCoordVarying2;

uniform sampler2D texture;
uniform sampler2D texture2;

void main()
{
    lowp vec4 texel  = TEXTURE2DBIAS(texture,  texCoordVarying,  -1.0);
    lowp vec4 texel2 = TEXTURE2DBIAS(texture2, texCoordVarying2, -1.0);

	lowp float	detailAlpha = (max(sign(texel2.y - PAPER_DETAIL_THRESHOLD), 0.0) * PAPER_DETAIL_ALPHA);
	
	lowp vec3	paperRGB = ((vec3(texel2.x, texel2.x, texel2.z) * PAPER_RGB_SCALE) + PAPER_RGB_OFFSET);
	//paperRGB = max(paperRGB, 1.0);

//	lowp vec3 combinedRGB = (texel.xyz * (1.0 - texel2.w)) + (texel2.xyz * texel2.w);
	lowp vec3 combinedRGB = ((texel.xyz * paperRGB) * (1.0 - detailAlpha)) + (PAPER_DETAIL_RGB * detailAlpha);

	gl_FragColor = vec4(combinedRGB, 1.0) * colorVarying;
}
