//
//  Shader_LightTex.fsh
//  CityBuilder
//
//  Created by Jonathan Webb on 18/08/2011.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#if defined (ANDROID)
#define TEXTURE2DBIAS(a,b,c)	texture2D(a,b)
#else
#define TEXTURE2DBIAS(a,b,c)	texture2D(a,b,c)
#endif

varying lowp vec4	colorVarying;
varying lowp vec2	texCoordVarying;
varying highp vec2	texCoordLightMapVarying;

uniform sampler2D	texture;
uniform sampler2D	texture2;
uniform sampler2D	nightlightmap;

uniform highp float	nightRatio;

void main()
{
	lowp vec4 tex0 = TEXTURE2DBIAS(texture,  texCoordVarying, -1.0);
	lowp vec4 tex1 = TEXTURE2DBIAS(texture2, texCoordVarying, -1.0);
	lowp vec4 tex2 = TEXTURE2DBIAS(nightlightmap, texCoordLightMapVarying, -1.0);

    //mediump vec3 rgb = TEXTURE2DBIAS(texture, texCoordVarying, -1.0) * colorVarying;
	mediump vec3 rgb = (tex0.xyz * colorVarying.xyz * (1.0 - nightRatio));
	rgb += (tex1.xyz * nightRatio);
	rgb += (tex0.xyz * tex2.xyz * nightRatio * (vec3(2.4, 1.6, 0.4) * 0.5));
	
	gl_FragColor = vec4(rgb, 1);
}

//------------------------------------------------------------------------------
