//
//  Shader_LightTex.fsh
//  CityBuilder
//
//  Created by Jonathan Webb on 18/08/2011.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#if defined (ANDROID)
#define TEXTURE2DBIAS(a,b,c)	texture2D(a,b)
#else
#define TEXTURE2DBIAS(a,b,c)	texture2D(a,b,c)
#endif

#define UW_RGB_SCALE	(0.7)

varying lowp vec4 varying_colour;
//varying lowp vec4 varying_fogColour;
varying lowp vec2 varying_texCoord;
varying lowp vec2 varying_texCoord2;

uniform sampler2D texture;
uniform sampler2D texture2;

void main()
{
	//gl_FragColor = TEXTURE2DBIAS(texture, varying_texCoord, -1.0) * varying_colour;
	
	lowp vec4 texel  = TEXTURE2DBIAS(texture,  varying_texCoord, -1.0);
	lowp vec4 texel2 = TEXTURE2DBIAS(texture2, varying_texCoord2, -1.0);
	
	lowp float	alpha = (varying_colour.w * texel2.w);
	
	lowp vec3 combinedRGB = (texel.xyz * (1.0 - alpha)) + (texel2.xyz * alpha);

//	lowp vec3 rgb   = ((combinedRGB * varying_colour.xyz) * varying_fogColour.w) + varying_fogColour.xyz;
	lowp vec3 rgb   = (combinedRGB * varying_colour.xyz);

	gl_FragColor = vec4((rgb * UW_RGB_SCALE), texel.w);
//	gl_FragColor = vec4(varying_colour.w, rgb.yz, texel.w) * vec4(1.0, 0.0, 0.0, 1.0);
	
}
