//
//  Shader_LightTex.fsh
//  CityBuilder
//
//  Created by Jonathan Webb on 18/08/2011.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#if defined (ANDROID)
#define TEXTURE2DBIAS(a,b,c)	texture2D(a,b)
#else
#define TEXTURE2DBIAS(a,b,c)	texture2D(a,b,c)
#endif

varying lowp	vec4 varying_colour;
varying mediump vec4 varying_fogColour;
varying mediump vec2 texCoordVarying;

uniform sampler2D texture;
uniform mediump vec4 addColour;

void main()
{
//	gl_FragColor = TEXTURE2DBIAS(texture, texCoordVarying, -1.0) * varying_colour;
	
	mediump vec4 texel = TEXTURE2DBIAS(texture, texCoordVarying, -1.0);
	
//	mediump vec3 finalRGB = ((texel.xyz * varying_colour.xyz) + varying_fogColour.xyz);
	mediump vec3 finalRGB = (texel.xyz * varying_colour.xyz);
	
	mediump float fogValue = (0.2 + clamp((varying_fogColour.w - 0.2), 0.0, 0.6)) * sign(max(varying_fogColour.w, 0.0));
	
	finalRGB = ((finalRGB * (1.0 - fogValue)) + (varying_fogColour.xyz * fogValue));
	
//	finalRGB = ((finalRGB * addColour.w) + addColour.xyz);
	
	mediump float intensity = dot(finalRGB, vec3(0.3, 0.5, 0.2));
	mediump vec3 tintedRGB = (addColour.xyz + vec3(intensity, intensity, intensity));
	finalRGB = (finalRGB * (1.0 - addColour.w)) + (tintedRGB * addColour.w);

	gl_FragColor = vec4(finalRGB, 1.0);//varying_colour
}

