//
//  Shader_PreLitTexReflectiveWater.fsh
//  CityBuilder
//
//  Created by Lee Metcalfe on 11/06/2011.
//  Copyright (c) 2011 Midoki Ltd. All rights reserved.
//

//------------------------------------------------------------------------------

#define TRANSITION_VERSION

//------------------------------------------------------------------------------

uniform sampler2D		texture;
uniform sampler2D		normalmap;
uniform sampler2D		reflectionmap;

#if defined (TRANSITION_VERSION)
uniform sampler2D		texture2;
uniform sampler2D		texture3;
#endif

//------------------------------------------------------------------------------

varying mediump vec2	varying_TexCoord;
varying mediump	vec2	varying_NormUV1;
//varying mediump	vec2	varying_NormUV2;
varying mediump	vec3	varying_V;

#if defined (TRANSITION_VERSION)
varying mediump vec2	varying_TexCoord2;
#endif

//------------------------------------------------------------------------------

void main()
{
	mediump	vec4	normal0Texel	= texture2D(normalmap, varying_NormUV1);
//	mediump	vec4	normal1Texel	= texture2D(normalmap, varying_NormUV2);
	
#if defined (TRANSITION_VERSION)
	mediump	vec4	diffuseTexel	= mix(texture2D(texture, varying_TexCoord), texture2D(texture2, varying_TexCoord), texture2D(texture3, varying_TexCoord2));
#else
	mediump	vec4	diffuseTexel	= texture2D(texture, varying_TexCoord);
#endif
	
	mediump	vec3	Vn				= normalize(varying_V);
	mediump	vec3	Ln				= vec3(0.57735, 0.57735, -0.57735);
	
	//	mediump	vec3	normal0			= ((2.0 * normal0Texel.xyz) - 1.0);
	//	mediump	vec3	normal1			= ((2.0 * normal1Texel.xyz) - 1.0);
	//	mediump	vec3	normal2			= min(vec3(1.0, 1.0, 1.0), (normal0 + normal1));
	mediump	vec3	normal2			= ((2.0 * normal0Texel.xyz) - 1.0);
	
	mediump	vec3	Nn				= normalize(vec3(normal2.y, (normal2.z + 1.0), -normal2.x));	// Equivalent to combining 2 normal maps in Blender with a strength of 0.5 each.
	
	mediump	float	NdotL			= dot(Nn, Ln);
	
	// Diffuse...
	mediump	float	diffuseLight	= max(0.0, (0.1 + (0.9 * NdotL)));
	mediump	vec3	ambientColour	= vec3(0.30, 0.30, 0.30);
	mediump	vec3	diffuseColour	= vec3(0.96, 0.96, 0.96);
	
 	mediump	vec3	finalRGB	= ((ambientColour + diffuseLight) * (diffuseTexel.xyz * diffuseColour));
	
	gl_FragColor = vec4(finalRGB, diffuseTexel.w);
}

//------------------------------------------------------------------------------
