//
//  Shader_LightTex.vsh
//  CityBuilder
//
//  Created by Jonathan Webb on 18/08/2011.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

//------------------------------------------------------------------------------

#define POS_COMPRESSION_FACTOR				(16.0)	//(16.0)
#define POS_COMPRESSION_FACTOR_SKIN			(256.0)	//(16.0)

#define XYZ_DECOMPRESSION_MULTIPLIER		(1.0/POS_COMPRESSION_FACTOR)
#define XYZ_DECOMPRESSION_MULTIPLIER_SKIN	(1.0/POS_COMPRESSION_FACTOR_SKIN)
#define UV_DECOMPRESSION_MULTIPLIER			(1.0/127.0)//1024.0)

//------------------------------------------------------------------------------

attribute vec4 position;
//attribute vec2 texCoord;

//------------------------------------------------------------------------------

uniform mat4 modelViewProjectionMatrix;
uniform vec4 animUV;

//------------------------------------------------------------------------------

varying lowp vec2 texCoordVarying;

//------------------------------------------------------------------------------

void main()
{
    // Transform the position into screen space.
    mediump vec3 posScaled = (position.xyz * XYZ_DECOMPRESSION_MULTIPLIER);
    gl_Position = modelViewProjectionMatrix * vec4(posScaled, 1.0);

	mediump	vec2	baseUVOffset	= fract(animUV.xy * animUV.zw);
	
    // Decompress the UVs
//	texCoordVarying = (texCoord * UV_DECOMPRESSION_MULTIPLIER);
	mediump float v = floor(position.w * (1.0 / 128.0));
	mediump float u = (position.w - (v * 128.0));
	texCoordVarying = (vec2((u * (1.0 / 127.0)), (v * (1.0 / 127.0))) + baseUVOffset);
}

//------------------------------------------------------------------------------
