//
//  Shader_LightTexSkinned.fsh
//  CityBuilder
//
//  Created by Ben Cohen on 05/04/2012.
//  Copyright (c) 2012 Midoki. All rights reserved.
//

varying lowp vec2 texCoordVarying;

uniform sampler2D texture;

void main()
{
	mediump vec4 colour = texture2D(texture, texCoordVarying);
	
	// NEW sepia shader, rather than completely desaturating the image, just do a simple blend...
	mediump float sepiaLevel = 0.75;
	mediump vec3 sepiaColour = vec3((65.0 / 255.0), (50.0 / 255.0), (34.0 / 255.0));
	mediump vec3 finalColour = ((sepiaColour * sepiaLevel) + (colour.xyz * (1.0 - sepiaLevel)));
	
	gl_FragColor = vec4(finalColour, colour.w);
}
