//
//  Shader_LightTex.fsh
//  CityBuilder
//
//  Created by Jonathan Webb on 18/08/2011.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

varying lowp	vec4 varying_colour;
varying mediump vec4 varying_fogColour;
varying mediump vec2 texCoordVarying;

uniform sampler2D texture;

void main()
{
//	gl_FragColor = texture2D(texture, texCoordVarying) * varying_colour;
	
	mediump vec4 texel = texture2D(texture, texCoordVarying);
	
//	mediump vec3 finalRGB = ((texel.xyz * varying_colour.xyz) + varying_fogColour.xyz);
	mediump vec3 finalRGB = (texel.xyz * varying_colour.xyz);
	
	mediump float fogValue = (0.2 + clamp((varying_fogColour.w - 0.2), 0.0, 0.6)) * sign(max(varying_fogColour.w, 0.0));
	
	finalRGB = ((finalRGB * (1.0 - fogValue)) + (varying_fogColour.xyz * fogValue));
	
	gl_FragColor = vec4(finalRGB, 1.0);//varying_colour
}

