//
//  Shader_LightTex.vsh
//  CityBuilder
//
//  Created by Jonathan Webb on 18/08/2011.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

//------------------------------------------------------------------------------

#define POS_COMPRESSION_FACTOR				(16.0)	//(16.0)
#define POS_COMPRESSION_FACTOR_SKIN			(256.0)	//(16.0)

#define XYZ_DECOMPRESSION_MULTIPLIER		(1.0/POS_COMPRESSION_FACTOR)
#define XYZ_DECOMPRESSION_MULTIPLIER_SKIN	(1.0/POS_COMPRESSION_FACTOR_SKIN)
#define UV_DECOMPRESSION_MULTIPLIER			(1.0/127.0)//1024.0)

//------------------------------------------------------------------------------

#define UWFOG_STRENGTH		(1.0)
#define UWFOG_START			(0.0)
#define UWFOG_END			(-6.0)
#define UWFOG_MULTIPLIER	(1.0 / (UWFOG_END - UWFOG_START))

//------------------------------------------------------------------------------

attribute vec4 position;
attribute vec2 texCoord;

//------------------------------------------------------------------------------

uniform highp	mat4 modelViewProjectionMatrix;
uniform highp	mat4 modelMatrix;
uniform mediump	vec4 uwTintColour;

//------------------------------------------------------------------------------

varying lowp	vec4 varying_colour;
varying mediump vec4 varying_fogColour;
varying mediump vec2 texCoordVarying;

//------------------------------------------------------------------------------

void main()
{
    // Transform the position into screen space.
    vec3 posScaled = (position.xyz * XYZ_DECOMPRESSION_MULTIPLIER);// - 2000.0;
    gl_Position = modelViewProjectionMatrix * vec4(posScaled, 1.0);
    //gl_Position = modelViewProjectionMatrix * position;
	
    // Decompress the UVs
    //texCoordVarying = texCoord;
//	texCoordVarying = (texCoord * UV_DECOMPRESSION_MULTIPLIER);
	mediump float v = floor(position.w * (1.0 / 128.0));
	mediump float u = (position.w - (v * 128.0));
	texCoordVarying = vec2((u * (1.0 / 127.0)), (v * (1.0 / 127.0)));
	
    // Apply the dots to the color matrix and copy to the output.
    mediump vec4 litColour = vec4(1.0, 1.0, 1.0, 1.0);
	
	//------------------------------------------------------------------------
	// Simple fogging effect to simulate the characters being underwater...
	//------------------------------------------------------------------------
	
	highp vec4 posWorld = (modelMatrix * vec4(posScaled, 1.0));
	
	mediump	float	fogValue = ((posWorld.y - UWFOG_START) * UWFOG_MULTIPLIER);
	fogValue = (fogValue * UWFOG_STRENGTH);
	//fogValue = max(fogValue, 0.0);
	//					fogValue = clamp(fogValue, 0.0, 1.0);
	
	//	fogValue = (sign(fogValue) * ((fogValue * 0.8) + 0.2));
	
	//	mediump vec3	foggedColour = (vec3(0.0, 0.5, 0.5) * fogValue);
	//	mediump vec3	foggedColour = (vec3(0.0, 0.4, 0.4) * fogValue);
	mediump vec3	foggedColour = uwTintColour.xyz;//vec3(0.05, 0.55, 0.5);
	
	//	litColour *= ((litColour * (1.0 - fogValue)) + vec4(0.5, 0.6, 0.7, 1.0) * fogValue);
	//	litColour *= ((litColour * (1.0 - fogValue)) + vec4(0.3, 0.5, 0.6, 1.0) * fogValue);
	//	litColour *= ((litColour * (1.0 - fogValue)) + vec4(0.1, 0.2, 0.2, 1.0) * fogValue);
	
	varying_colour = litColour;
	varying_fogColour = vec4(foggedColour, fogValue);
}

//------------------------------------------------------------------------------

