//
//  Shader_LightTex.vsh
//  CityBuilder
//
//  Created by Jonathan Webb on 18/08/2011.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

//------------------------------------------------------------------------------

#define POS_COMPRESSION_FACTOR				(16.0)	//(16.0)
#define POS_COMPRESSION_FACTOR_SKIN			(256.0)	//(16.0)

#define XYZ_DECOMPRESSION_MULTIPLIER		(1.0/POS_COMPRESSION_FACTOR)
#define XYZ_DECOMPRESSION_MULTIPLIER_SKIN	(1.0/POS_COMPRESSION_FACTOR_SKIN)
#define UV_DECOMPRESSION_MULTIPLIER			(1.0/127.0)//1024.0)

//------------------------------------------------------------------------------

attribute vec4 position;
attribute vec3 normal;
attribute vec2 texCoord;

//------------------------------------------------------------------------------

uniform mat4 modelViewProjectionMatrix;
uniform vec4 animUV;

//------------------------------------------------------------------------------

varying mediump vec2 texCoordVarying;

//------------------------------------------------------------------------------

void main()
{
    // Transform the position into screen space.
    vec3			posScaled			= (position.xyz * XYZ_DECOMPRESSION_MULTIPLIER);
	vec4			posScaled4			= vec4(posScaled, 1.0);
	vec4			posTrans			= modelViewProjectionMatrix * posScaled4;
	
	gl_Position							= posTrans;
	
	mediump	vec2	baseUVOffset		= fract(animUV.xy * animUV.zw);
	
//	texCoordVarying.xy		= ((texCoord/1024.0) + baseUVOffset);
	texCoordVarying.xy		= ((vec2(-posScaled.x, posScaled.z) * 0.01) + baseUVOffset);
}

//------------------------------------------------------------------------------






