//
//  Shader_PreLitTexReflectiveWater.fsh
//  CityBuilder
//
//  Created by Lee Metcalfe on 11/06/2011.
//  Copyright (c) 2011 Midoki Ltd. All rights reserved.
//

//------------------------------------------------------------------------------

#define PI 3.1415926

#define NORMALMAP_FLATTEN_FACTOR	(2.0)//(0.0)

//------------------------------------------------------------------------------

uniform sampler2D		texture;
uniform sampler2D		texture2;
uniform lowp    vec4    waterEdgeColour;

//------------------------------------------------------------------------------

varying mediump	vec2	varying_texCoord;
varying mediump	vec3	varying_WaveUV_EdgeRatio;

//------------------------------------------------------------------------------

void main()
{
	lowp	vec4	diffuseColor	= vec4(1.0, 1.0, 1.0, 1.0);
	
	mediump	vec4	waveTexel		= texture2D(texture, varying_WaveUV_EdgeRatio.xy);
	mediump	vec4	waterTexel		= texture2D(texture2, varying_texCoord.xy);
	
	mediump float	edgeRatio		= varying_WaveUV_EdgeRatio.z;
	
	mediump float	finalWaveAlpha	= min((1.0 - edgeRatio), edgeRatio) * 2.0;
	mediump float	finalWave		= (waveTexel.w * finalWaveAlpha);
	
	mediump vec3	finalRGB		= ((waterTexel.xyz * (1.0 - finalWave)) + (waveTexel.xyz * finalWave));
	
	gl_FragColor = vec4(finalRGB, 1.0);
}

//------------------------------------------------------------------------------

