//
//  Shader_PreLitTexReflectiveWater.vsh
//  CityBuilder
//
//  Created by Lee Metcalfe on 11/06/2011.
//  Copyright (c) 2011 Midoki Ltd. All rights reserved.
//

//------------------------------------------------------------------------------

#define POS_COMPRESSION_FACTOR				(16.0)	//(16.0)
#define POS_COMPRESSION_FACTOR_SKIN			(256.0)	//(16.0)

#define XYZ_DECOMPRESSION_MULTIPLIER		(1.0/POS_COMPRESSION_FACTOR)
#define XYZ_DECOMPRESSION_MULTIPLIER_SKIN	(1.0/POS_COMPRESSION_FACTOR_SKIN)

//------------------------------------------------------------------------------

attribute vec4 position;
//attribute vec2 texCoord;

//------------------------------------------------------------------------------

uniform highp	mat4	modelViewProjectionMatrix;
uniform highp	vec4	animUV;

//------------------------------------------------------------------------------

varying mediump	vec3	varying_WaveUV_EdgeRatio;

//------------------------------------------------------------------------------

void main()
{
    // Transform the position into screen space.
    vec3	posScaled			= (position.xyz * XYZ_DECOMPRESSION_MULTIPLIER);
	vec4	posScaled4			= vec4(posScaled, 1.0);
	vec4	posTrans			= modelViewProjectionMatrix * posScaled4;

	gl_Position							= posTrans;
	
//	mediump vec2	texCoordScaled		= (texCoord.xy/1024.0);
	mediump float v = floor(position.w * (1.0 / 128.0));
	mediump float u = (position.w - (v * 128.0));
	mediump vec2	texCoordScaled = vec2((u * (1.0 / 127.0)), (v * (1.0 / 127.0)));

	mediump vec2	baseUVOffset		= fract(animUV.xy * animUV.zw);
	mediump vec2	waveUVOffset		= fract(baseUVOffset * vec2(4.0, -6.0));
					
	mediump vec2	waveUV				= (texCoordScaled.xy + waveUVOffset);
	mediump float	waveEdgeRatio		= max(abs(texCoordScaled.y), 0.0);

	varying_WaveUV_EdgeRatio			= vec3(waveUV, waveEdgeRatio);
}

//------------------------------------------------------------------------------
