//
//  Shader_PreLitTexReflectiveWater.fsh
//  CityBuilder
//
//  Created by Lee Metcalfe on 11/06/2011.
//  Copyright (c) 2011 Midoki Ltd. All rights reserved.
//

//------------------------------------------------------------------------------

#define REFLECTION

//------------------------------------------------------------------------------

#define PI 3.1415926

//------------------------------------------------------------------------------

uniform sampler2D texture;

#if defined (REFLECTION)
uniform sampler2D		normalmap;
uniform sampler2D		reflectionmap;
#endif

//------------------------------------------------------------------------------

varying lowp	vec4	colorVarying;

varying highp	vec2	texCoordVarying;

#if defined (REFLECTION)
varying highp	vec2	texCoordVarying2;
varying mediump	vec3	eyeVectorVarying;
varying mediump	vec3	reflectVectorVarying;
#endif

//------------------------------------------------------------------------------

void main()
{
	lowp	vec4	diffuseColor = texture2D(texture, texCoordVarying);
	
#if defined (REFLECTION)
	
	// Fast version
	mediump	vec3	normal = ((2.0 * texture2D(normalmap, texCoordVarying2).xyz) - 1.0);
	mediump vec3	refl = normalize(reflectVectorVarying + normal);
	mediump vec2	uv = ((refl.xy * 0.5) + 0.5);
	
	mediump vec4	reflection = texture2D(reflectionmap, uv);
	
	gl_FragColor = (diffuseColor * colorVarying) + (reflection * colorVarying * 0.5);
	
#else
	
    gl_FragColor = (diffuseColor * colorVarying);
	
#endif
}

//------------------------------------------------------------------------------
