//
//  Shader_PreLitTexAnimUV.fsh
//  CityBuilder
//
//  Created by Jonathan Webb on 18/08/2011.
//  Copyright (c) 2011 Midoki Ltd. All rights reserved.
//

//------------------------------------------------------------------------------

#if defined (ANDROID)
#define TEXTURE2DBIAS(a,b,c)	texture2D(a,b)
#else
#define TEXTURE2DBIAS(a,b,c)	texture2D(a,b,c)
#endif

uniform sampler2D		texture;
uniform sampler2D		nightlightmap;

uniform highp	float	nightRatio;

//------------------------------------------------------------------------------

varying lowp	vec4	colorVarying;
varying highp	vec2	texCoordVarying;
varying highp	vec2	texCoordLightMapVarying;

//------------------------------------------------------------------------------

void main()
{
    lowp vec4 tex0 = TEXTURE2DBIAS(texture, texCoordVarying, -1.0);
    lowp vec4 tex1 = TEXTURE2DBIAS(nightlightmap, texCoordLightMapVarying, -1.0);

////mediump vec3 rgb = (tex0.xyz * colorVarying.xyz * (1.0 - (nightRatio * 0.8))) + (tex1.xyz * nightRatio);
//	mediump vec3 rgb = (tex0.xyz * colorVarying.xyz * (1.0 - nightRatio)) + ((tex0.xyz * tex1.xyz) * nightRatio * vec3(2.0, 1.5, 0));

//	mediump vec3 rgb = (tex0.xyz * colorVarying.xyz) + ((tex0.xyz * tex1.xyz) * nightRatio * vec3(1.2, 0.9, 0.3));
	mediump vec3 rgb = (tex0.xyz * colorVarying.xyz) + ((tex0.xyz * tex1.xyz) * nightRatio * vec3(2.4, 1.6, 0.4));
	
    gl_FragColor = vec4(rgb, 1);
}

//------------------------------------------------------------------------------
