//
//  Shader_PreLitTexReflectiveWater.vsh
//  CityBuilder
//
//  Created by Lee Metcalfe on 11/06/2011.
//  Copyright (c) 2011 Midoki Ltd. All rights reserved.
//

//------------------------------------------------------------------------------

#define POS_COMPRESSION_FACTOR				(16.0)	//(16.0)
#define POS_COMPRESSION_FACTOR_SKIN			(256.0)	//(16.0)

#define XYZ_DECOMPRESSION_MULTIPLIER		(1.0/POS_COMPRESSION_FACTOR)
#define XYZ_DECOMPRESSION_MULTIPLIER_SKIN	(1.0/POS_COMPRESSION_FACTOR_SKIN)
#define UV_DECOMPRESSION_MULTIPLIER			(1.0/1024.0)

#define COMPRESSED_LIGHT_RATIOS

//#define REFLECTION

#define NORMALMAP_UV_MULTIPLIER1			(1.0/256.0)
#define NORMALMAP_UV_MULTIPLIER2			(1.0/500.0)

//------------------------------------------------------------------------------

attribute vec4 position;
attribute vec2 texCoord;

//------------------------------------------------------------------------------

uniform highp	mat4	modelViewProjectionMatrix;

uniform highp	vec4	animUV;

#if defined (REFLECTION)
uniform highp	mat4	modelViewMatrix;
#endif

//------------------------------------------------------------------------------

//varying highp	vec2	texCoordVarying;	// highp needed to avoid inaccuracies in the anim uv's

#if defined (REFLECTION)
varying mediump	vec2	texCoordVarying2;
varying mediump	vec3	reflectVectorVarying;
#endif

//------------------------------------------------------------------------------

void main()
{
    // Transform the position into screen space.
	mediump vec3	posScaled = (position.xyz * XYZ_DECOMPRESSION_MULTIPLIER);
	mediump vec4	posScaled4 = vec4(posScaled, 1.0);
	gl_Position = modelViewProjectionMatrix * posScaled4;
    //gl_Position = modelViewProjectionMatrix * position;
	
    // Decompress UVs
//	texCoordVarying = animUV.xy + texCoord;
	mediump	vec2	baseUVOffset	= fract(animUV.xy * animUV.zw);
    
//	texCoordVarying = baseUVOffset + (texCoord/1024.0);
	
#if defined (REFLECTION)
	mediump	vec2	texCoordWorld	= vec2(posScaled.x, posScaled.z) * 1.5;//3.0;//8.0;
	mediump	vec2	normUV1			= ((texCoordWorld * NORMALMAP_UV_MULTIPLIER1) + baseUVOffset);
//	mediump	vec2	normUV2			= ((texCoordWorld * NORMALMAP_UV_MULTIPLIER2) + (baseUVOffset * 2.0));

    texCoordVarying2 = normUV1;
	
	// New fast approximation of reflection shader - calculate reflection vector in VS and then do a hacky distort in FS...
	vec3			posVS       = (modelViewMatrix * posScaled4).xyz;
	mediump vec3	eyeVectorVS = normalize(posVS);
	mediump	vec3	normal = vec3(0,0,1);
	
//	reflectVectorVarying = reflect(eyeVectorVS, normal) * 32.0;
	reflectVectorVarying = vec3(eyeVectorVS.x, -eyeVectorVS.y, eyeVectorVS.z) * 32.0;
#endif
}

//------------------------------------------------------------------------------
