//
//  Shader_PreLitTexReflectiveWater.fsh
//  CityBuilder
//
//  Created by Lee Metcalfe on 11/06/2011.
//  Copyright (c) 2011 Midoki Ltd. All rights reserved.
//

//------------------------------------------------------------------------------

#define PI 3.1415926

#define NORMALMAP_FLATTEN_FACTOR	(2.0)//(0.0)

//------------------------------------------------------------------------------

uniform sampler2D		texture;
uniform lowp    vec4    waterEdgeColour;

//------------------------------------------------------------------------------

varying mediump	vec3	varying_WaveUV_EdgeRatio;

//------------------------------------------------------------------------------

void main()
{
	lowp	vec4	diffuseColor	= vec4(1.0, 1.0, 1.0, 1.0);

	mediump	vec4	waveTexel		= texture2D(texture, varying_WaveUV_EdgeRatio.xy);
	
	mediump float	edgeRatio		= varying_WaveUV_EdgeRatio.z;

	mediump float	finalWaveAlpha	= min((1.0 - edgeRatio), edgeRatio) * 2.0;
	mediump vec3	finalWave		= (waveTexel.xyz * waveTexel.w) * finalWaveAlpha;

	gl_FragColor = vec4(waveTexel.xyz, (waveTexel.w * finalWaveAlpha)) * waterEdgeColour;
}

//------------------------------------------------------------------------------
